function AttachEvent(obj,evt,fnc,useCapture){
	if (!useCapture) useCapture=false;
	if (obj.addEventListener){
		obj.addEventListener(evt,fnc,useCapture);
		return true;
	} else if (obj.attachEvent) return obj.attachEvent("on"+evt,fnc);
	else{
		MyAttachEvent(obj,evt,fnc);
		obj['on'+evt]=function(){ MyFireEvent(obj,evt) };
	}
} 
function MyAttachEvent(obj,evt,fnc){
	if (!obj.myEvents) obj.myEvents={};
	if (!obj.myEvents[evt]) obj.myEvents[evt]=[];
	var evts = obj.myEvents[evt];
	evts[evts.length]=fnc;
}
function MyFireEvent(obj,evt){
	if (!obj || !obj.myEvents || !obj.myEvents[evt]) return;
	var evts = obj.myEvents[evt];
	for (var i=0,len=evts.length;i<len;i++) evts[i]();
}

function CancelBubble(evt){
	evt.cancelBubble=true;
	if (typeof evt.stopPropagation=='function') evt.stopPropagation();
	return false;
}
function PreventDefault(evt){ 
	if (!evt && window.event) evt=window.event;
	evt.returnValue=false;
	if (typeof evt.preventDefault=='function') evt.preventDefault();
	return false;
}


function AddClass(obj,cName){ KillClass(obj,cName); return obj.className+=(obj.className.length>0?' ':'')+cName; }
function KillClass(obj,cName){ return obj.className=obj.className.replace(new RegExp("^"+cName+"\\b\\s*|\\s*\\b"+cName+"\\b",'g'),''); }
function HasClass(obj,cName){ return (!obj || !obj.className)?false:(new RegExp("\\b"+cName+"\\b")).test(obj.className) }



function HandleEventForObject(evt){
	if (!evt && window.event) evt=window.evt;
	if (!evt) return alert("Couldn't find an event object for HandleEventForObject");
	var el = evt.target || evt.srcElement;
	while (el && (!el.jsObj || typeof el.jsObj.handleEvent!='function')) el=el.parentNode;
	if (!el) return alert("Couldn't find a handling object for HandleEventForObject");
	el.jsObj.handleEvent(evt);
}



Object.prototype.toSourceCode=function(hier,lv,forObj){
	var out,tabs='',idre=/^[a-z_][a-z0-9_]*$/i;
	if (!lv) lv=0;
	if (hier) tabs=Math.pow(10,lv).toString().substr(1).replace(/0/g,"\t");
	if (this.constructor==Array){
		out=(forObj?'':tabs)+'['+(hier?'\n':'');
		for (var i=0,len=this.length;i<len;i++) out+=((this[i]!=null)?this[i].toSourceCode(hier,lv+1):'null')+(i<(len-1)?',':'')+(hier?'\n':'');
		return out+tabs+']';
	}else if(this.constructor==Object){
		out=(forObj?'':tabs)+'{'+(hier?'\n':'');
		for (var key in this) if (key!='toSourceCode') out+=tabs+(hier?'\t':'')+(idre.test(key)?key:("'"+key+"'"))+":"+(this[key]==null?'null':this[key].toSourceCode(hier,lv+1,true))+","+(hier?'\n':'');
		out=out.replace(/,(\n?)$/,'$1');
		return out+tabs+'}';
	}else if(typeof(this)=='string') return (forObj?'':tabs)+"'"+this+"'";
	else if(this.constructor==Date) return (forObj?'':tabs)+"new Date("+this.valueOf()+")";
	else return (forObj?'':tabs)+this.toString();
}


function winalert(msg){
	open("javascript:'<xmp>"+msg+"</xmp>'");
}


function RadioButtonValue(frm,radioName){
	var radios = frm.elements[radioName];
	for (var i=0,len=radios.length;i<len;i++) if (radios[i].checked) return radios[i].value;
	return null;
}


Array.prototype.removeItem=function(el){
	for (var i=0;i<this.length;i++) if (this[i]==el) this.splice(i,1);
}