/* ToDo:
 * shiftKey for range selection
 * keyboard navigation inside select
 */
 
// **********************************************************************
function DHTMLOptionBox(sel){
// **********************************************************************
	this.options=[];
	this.sel=sel;
	this.multiple=sel.multiple;
	var g=this.g=document.createElement('div');
	if (sel.id) g.id=sel.id;
	g.jsObj=this;
	g.options=this.options;
	g.className=sel.className;
	g.style.height=sel.size+'em';
	sel.parentNode.replaceChild(g,sel);
	AttachEvent(g,'click',HandleEventForObject,false);
	AttachEvent(g,'selectstart',PreventDefault,false);
	this.populate(sel);
	this.changefunc = window[sel.getAttribute('onchangef')] || null;
}
DHTMLOptionBox.prototype.appendChild=function(obj){
	if (obj.constructor==DHTMLOption) this.options.push(obj);
	obj.owner=this;
	this.g.appendChild(obj.g);

	this.g.scrollTop+=1; //Safari redraw hack
	this.g.scrollTop-=1;

	if (this.changefunc) this.changefunc(this);

	return this;
}
DHTMLOptionBox.prototype.removeChild=function(opt){
	opt.g.parentNode.removeChild(opt.g);
	opt.owner.options.removeItem(opt);
	this.options.removeItem(opt);
}

DHTMLOptionBox.prototype.handleEvent=function(evt){
	switch(evt.type){
		case 'click':
			this.handleClick(evt);
			break;
		default:
			return alert("Unhandled event type '"+evt.type+"' for "+this+".handleEvent()");
	}
}	
DHTMLOptionBox.prototype.handleClick=function(evt,opt){
	if (!opt) this.deselect();
	else{
		var wasSelected = opt && opt.selected;
		var toggle = evt.metaKey || evt.ctrlKey;
		if (!this.multiple || (!toggle && !evt.shiftKey)) this.deselect();
		if (wasSelected && toggle) opt.deselectThyself();
		else opt.selectThyself();
		if (evt.shiftKey && this.lastClicked && this.lastClicked!=opt){
			for (var i=this.options.length-1,on=false;i>=0;i--){
				var tmp = this.options[i];
				if (!on && tmp!=this.lastClicked && tmp!=opt) continue;
				var boundary = (tmp==this.lastClicked || tmp==opt);
				if (on || boundary) tmp.selectThyself();
				if (boundary) on=!on;
			}
		}
		this.lastClicked=opt;
	}

	this.selectedIndex=this.g.selectedIndex=-1;
	for (var i=this.options.length-1;i>=0;i--) if (this.options[i].selected) this.selectedIndex=this.g.selectedIndex=i;

	this.g.scrollTop+=1; //Safari redraw hack
	this.g.scrollTop-=1;
	
	if (this.changefunc) this.changefunc(this);
}
DHTMLOptionBox.prototype.deselect=function(){
	for (var i=this.options.length-1;i>=0;i--) this.options[i].deselectThyself();
}
DHTMLOptionBox.prototype.populate=function(origParent){
	for (var i=0,len=origParent.childNodes.length;i<len;i++){
		var el = origParent.childNodes.item(i);
		if (!el.tagName) continue;
		switch(el.tagName.toLowerCase()){
			case 'optgroup':
				var group = new DHTMLOptionGroup(el.label);
				this.appendChild(group);
				if (el.id) group.g.id=el.id;
				group.populate(el);
				break;
				
			case 'option':
				this.appendChild(new DHTMLOption(el.value,el.text,el.selected));
				break;
		}
	}
}
DHTMLOptionBox.prototype.addSubOpt=function(opt){
	this.options.push(opt);
	if (this.owner) this.owner.addSubOpt(opt);
}

DHTMLOptionBox.init=function(){
	DHTMLOptionBox.all=[];
	var allSelects=[];
	for (var i=0,alls=document.getElementsByTagName('select'),len=alls.length;i<len;i++) allSelects.push(alls[i]);
	for (var i=0,len=allSelects.length;i<len;i++){		
		var sel = allSelects[i];
		if (!HasClass(sel,'dhtmloptionbox') || sel.size<=1) continue;
		DHTMLOptionBox.all.push(new DHTMLOptionBox(sel));
	}
}

DHTMLOptionBox.prototype.toString=function(){ return '[DHTMLOptionBox]' }











// **********************************************************************
function DHTMLOptionGroup(label){
// **********************************************************************
	this.options=[];
	var g=this.g=document.createElement('div');
	g.jsObj=this;
	g.className='optgroup';
	g.innerHTML=label;
}
DHTMLOptionGroup.prototype.appendChild=function(opt){
	opt.owner=this;
	this.addSubOpt(opt);
	this.g.appendChild(opt.g);
	this.owner.g.scrollTop+=1;
	this.owner.g.scrollTop-=1;

	if (this.owner.changefunc) this.owner.changefunc(this);

	return opt;
}
DHTMLOptionGroup.prototype.populate=DHTMLOptionBox.prototype.populate;
DHTMLOptionGroup.prototype.addSubOpt=DHTMLOptionBox.prototype.addSubOpt;
DHTMLOptionGroup.prototype.toString=function(){ return '[DHTMLOptionGroup]' }










// **********************************************************************
function DHTMLOption(value,text,selected){
// **********************************************************************
	this.value=value;
	this.text=text;
	this.selected=!!selected;
	var g=this.g=document.createElement('div');
	g.className='option';
	g.jsObj=this;
	g.innerHTML=text;
	AttachEvent(g,'click',HandleEventForObject,false);
}
DHTMLOptionGroup.prototype.selectOption=DHTMLOption.prototype.select=function(){
	if (this.owner) this.owner.selectOption(this);
}
DHTMLOptionGroup.prototype.deselectOption=DHTMLOption.prototype.deselect=function(){
	if (this.owner) this.owner.deselectOption(this);
}
DHTMLOption.prototype.selectThyself=function(){
	AddClass(this.g,'selected');
	this.selected=true;
}
DHTMLOption.prototype.deselectThyself=function(){
	KillClass(this.g,'selected');
	this.selected=false;
}

DHTMLOption.prototype.cloneNode=function(){
	return new DHTMLOption(this.value,this.text);
}

DHTMLOption.prototype.handleEvent=function(evt){
	switch(evt.type){
		case 'click':
			this.handleClick(evt);
			break;
		default:
			return alert("Unhandled event type '"+evt.type+"' for "+this+".handleEvent()");
	}
}
DHTMLOption.prototype.handleClick=function(evt){
	var sel=this;
	while (sel.owner) sel=sel.owner;
	if (sel==this) return alert("ERROR: DHTMLOption.handleClick() doesn't have an owner select to delegate to.");
	sel.handleClick(evt,this);
	CancelBubble(evt);
}
DHTMLOption.prototype.toString=function(){ return '[DHTMLOption "'+this.text+' ('+this.value+')"]' }


AttachEvent(window,'load',DHTMLOptionBox.init,false);
